#import <OpenGL/gl.h>
#import <OpenGL/glext.h>
#import <OpenGL/glu.h>

#import <vector>

#import "Track.h"
#import "Renderer.h"
#import "Synthesizer.h"

#import "stk/Stk.h"
#import "stk/RtAudio.h"

int audioCallback(void *outputBuffer, void *inputBuffer, unsigned int nFrames, double streamTime, RtAudioStreamStatus status, void *user_data);

@interface EL2OpenGLView : NSOpenGLView {
	NSTimer* timer;
	CGSize m_size;
	
	// the global track
	std::vector<Track *> *m_tracks;
	int m_currentTrack;
	
	// the root renderer and synthesizer
	Renderer *m_renderer;
	Synthesizer *m_synthesizer;
	
	// RtAudio
	RtAudio *m_audio;
}

// load and save
- (NSString *)projectArchive;
- (void)loadProjectArchive:(NSString *)project;

// input event handlers
- (void)keyDown:(NSEvent *)theEvent;
//- (void)mouseDown:(NSEvent *)theEvent;
//- (void)rightMouseDown:(NSEvent *)theEvent;
//- (void)otherMouseDown:(NSEvent *)theEvent;
//- (void)mouseUp:(NSEvent *)theEvent;
//- (void)rightMouseUp:(NSEvent *)theEvent;
//- (void)otherMouseUp:(NSEvent *)theEvent;

// drawing event handlers
- (void)prepareOpenGL;
- (void)updateMatrices;
- (void)drawRect:(NSRect)rect;

// helpers
- (void)addTrack;
- (void)addTrack:(Track *)t;
- (void)setCurrentTrack:(int)i;

// initialization, etc.
- (void)awakeFromNib;
- (BOOL)acceptsFirstResponder;
- (BOOL)becomeFirstResponder;
- (BOOL)resignFirstResponder;

@end
