/*
 *  Note.h
 *  everylayer
 *
 *  Created by Andrew on 11/28/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef __NOTE__
#define __NOTE__

#include "stk/Stk.h"
#include <string>

#include <boost/serialization/access.hpp>

using namespace std;

// model to represent a note (immutable)
class Note
{
public:
	Note();
    Note(unsigned int startTime, unsigned int stopTime, stk::StkFloat frequency, stk::StkFloat amplitude);
	
	unsigned int startTime();
	unsigned int stopTime();
	stk::StkFloat frequency();
	stk::StkFloat amplitude();
	
protected:
	unsigned int m_startTime;
	unsigned int m_stopTime;
	stk::StkFloat m_frequency;
	stk::StkFloat m_amplitude;

private:
    friend class boost::serialization::access;
	
    template<class Archive>
    void serialize(Archive & ar, const unsigned int version)
    {
        ar & m_startTime;
        ar & m_stopTime;
        ar & m_frequency;
        ar & m_amplitude;
    }
};

#endif // __NOTE__
