/*
 *  Renderer.h
 *  everylayer
 *
 *  Created by Andrew on 11/28/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef __RENDERER__
#define __RENDERER__


#include "vector3d.h"

// OpenGL
#include <GLUT/glut.h>
#include <OpenGL/gl.h>
#include <OpenGL/glu.h>

#include <vector>

using namespace std;

// model to represent a track
class Renderer
{
public:
    Renderer();
	~Renderer();
	
	void addChild(Renderer *child);
	void removeChild(Renderer *child);
	void removeAllChildren();
	Renderer * childAt(unsigned int i);
	unsigned int numChildren();
	
	virtual void interpolate(GLfloat delta = 1.0f);	
	void render();
	
	void setPosition(GLfloat x, GLfloat y, GLfloat z);
	void setScale(GLfloat x, GLfloat y, GLfloat z);
	virtual void setColor(GLfloat r, GLfloat g, GLfloat b);
	virtual void setAlpha(GLfloat a);
	
	GLfloat xPosition() { return m_xPosition->goal; }
	GLfloat yPosition() { return m_yPosition->goal; }
	GLfloat zPosition() { return m_zPosition->goal; }
	GLfloat xScale() { return m_xScale->goal; }
	GLfloat yScale() { return m_yScale->goal; }
	GLfloat zScale() { return m_zScale->goal; }
	virtual GLfloat rColor() { return m_rColor->goal; }
	virtual GLfloat gColor() { return m_gColor->goal; }
	virtual GLfloat bColor() { return m_bColor->goal; }
	virtual GLfloat alpha() { return m_aColor->goal; }
	
protected:
	
	void pushProperties();
	void popProperties();
	virtual void renderSelf();
	void renderChildren();
	
	vector<Renderer *> *m_children;
	
    Vector3D *m_xPosition;
    Vector3D *m_yPosition;
    Vector3D *m_zPosition;
	
    Vector3D *m_xScale;
    Vector3D *m_yScale;
    Vector3D *m_zScale;
	
    Vector3D *m_rColor;
    Vector3D *m_gColor;
    Vector3D *m_bColor;
	
    Vector3D *m_aColor;
};

#endif // __RENDERER__
