//
//  SharedProjectTableViewController.m
//  everylayer2
//
//  Created by Andrew on 12/6/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "SharedProjectTableViewController.h"

#import <Quartz/Quartz.h>

@implementation SharedProjectTableViewController

@synthesize tableView;

- (id)initWithTableView:(NSTableView *)t array:(NSArray *)a {
	if (self = [super init]) {
		tableView = t;
		[tableView setDataSource:self];
		[tableView setDelegate:self];
		
		dataArray = a;
	}
	
	return self;
}

#pragma mark DataSource methods

- (NSInteger)numberOfRowsInTableView:(NSTableView *)aTableView {
	return [dataArray count];
}


- (id)tableView:(NSTableView *)aTableView objectValueForTableColumn:(NSTableColumn *)aTableColumn row:(NSInteger)rowIndex {
	if ([[aTableColumn identifier] isEqualToString:@"image"]) {
		NSData *imageData = [(NSDictionary *)[dataArray objectAtIndex:rowIndex] objectForKey:[aTableColumn identifier]];
		NSImage *image = [[NSImage alloc] initWithData:imageData];
		return [image autorelease];
	} else {
		return [(NSDictionary *)[dataArray objectAtIndex:rowIndex] objectForKey:[aTableColumn identifier]];
	}
}

#pragma mark Delegate methods

- (void)tableView:(NSTableView *)aTableView willDisplayCell:(id)aCell forTableColumn:(NSTableColumn *)aTableColumn row:(NSInteger)rowIndex {
	
}

- (NSCell *)tableView:(NSTableView *)tableView dataCellForTableColumn:(NSTableColumn *)tableColumn row:(NSInteger)row {
	NSCell *cell = nil;
	
	if (tableColumn) {
		cell = [tableColumn dataCellForRow:row];
	}
	
	return cell;
}

/*- (CGFloat)tableView:(NSTableView *)tableView heightOfRow:(NSInteger)row {
	
}*/

#pragma mark -

- (void)dealloc {
	[tableView release];
	tableView = nil;
	
	[super dealloc];
}

@end
