/*
 *  Synthesizer.h
 *  everylayer
 *
 *  Created by Andrew on 11/28/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef __SYNTHESIZER__
#define __SYNTHESIZER__

#include <pthread.h>
#include <vector>
#include "stk/Stk.h"

using namespace std;

// model to represent a track
class Synthesizer
{
public:
    Synthesizer();
	~Synthesizer();
	
	void addChild(Synthesizer *child);
	void removeChild(Synthesizer *child);
	void removeAllChildren();
	Synthesizer * childAt(unsigned int i);
	unsigned int numChildren();
	
	stk::StkFloat tick(stk::StkFloat inputSample = 0);
	
protected:
	
	virtual stk::StkFloat synthesizeSelf(stk::StkFloat inputSample);
	stk::StkFloat synthesizeChildren(stk::StkFloat inputSample);
	
	vector<Synthesizer *> *m_children;
	
	pthread_mutex_t m_childrenMutex;
};

#endif // __SYNTHESIZER__
