/*
 *  Track.h
 *  everylayer
 *
 *  Created by Andrew on 11/28/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef __TRACK__
#define __TRACK__

#include "Note.h"
#include <pthread.h>
#include <vector>
#include <string>

#include <boost/serialization/access.hpp>
#include <boost/serialization/vector.hpp>

using namespace std;


// model to represent a track
class Track
{
	
public:
	
	Track();
    Track(unsigned int duration, unsigned int instrumentID);
	~Track();
	
	unsigned int nextSample();
	void setNextSample(unsigned int n);
	void advanceNextSample();
	
	unsigned int duration();
	
	unsigned int instrumentID();
	void setInstrumentID(unsigned int instrumentID);
	
	void addNote(unsigned int startTime, unsigned int stopTime, stk::StkFloat frequency, stk::StkFloat amplitude);
	void removeNote(Note *note);
	Note * noteAt(unsigned int i);
	unsigned int numNotes();
	
	bool selected() { return m_selected; }
	void select() { m_selected = true; }
	void deselect() { m_selected = false; }
	
protected:
	
	unsigned int m_nextSample;
	unsigned int m_duration;
	unsigned int m_instrumentID;
	vector<Note *> *m_notes;
	pthread_mutex_t m_notesMutex;
	
	bool m_selected;

private:
    friend class boost::serialization::access;
	
    template<class Archive>
    void serialize(Archive & ar, const unsigned int version)
    {
        ar & m_duration;
        ar & m_instrumentID;
        ar & m_notes;
    }
};

#endif // __TRACK__
