/*
 *  TrackRenderer.h
 *  everylayer
 *
 *  Created by Andrew on 11/28/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef __TRACK_RENDERER__
#define __TRACK_RENDERER__


#include "Renderer.h"
#include "Track.h"

// OpenGL
#include <GLUT/glut.h>
#include <OpenGL/gl.h>
#include <OpenGL/glu.h>

#include "vector3d.h"

// Renderer subclass that knows how to draw Tracks
class TrackRenderer : public Renderer {

public:
	// TrackRenderer does not own the Track it renders
	TrackRenderer(Track *track);
	~TrackRenderer();
	
	Track * track();
	
	void setWidth(GLfloat w);
	void setHeight(GLfloat h);

	void setColor(GLfloat r, GLfloat g, GLfloat b);
	void setAlpha(GLfloat a);
	
	void setSelectedColor(GLfloat r, GLfloat g, GLfloat b);
	void setSelectedAlpha(GLfloat a);

	GLfloat rColor() { return m_deselectedRColor; }
	GLfloat gColor() { return m_deselectedGColor; }
	GLfloat bColor() { return m_deselectedBColor; }
	GLfloat alpha() { return m_deselectedAColor; }
	
	GLfloat selectedRColor() { return m_selectedRColor; }
	GLfloat selectedGColor() { return m_selectedGColor; }
	GLfloat selectedBColor() { return m_selectedBColor; }
	GLfloat selectedAlpha() { return m_selectedAColor; }
	
	void interpolate(GLfloat delta = 1.0f);
	
protected:
	void renderSelf();
	
	Track *m_track;
	
	Vector3D *m_width;
	Vector3D *m_height;
	
	GLfloat m_deselectedRColor;
	GLfloat m_deselectedGColor;
	GLfloat m_deselectedBColor;
	GLfloat m_deselectedAColor;
	
	GLfloat m_selectedRColor;
    GLfloat m_selectedGColor;
    GLfloat m_selectedBColor;
    GLfloat m_selectedAColor;
};

#endif // __TRACK_RENDERER__
