/*
 *  TrackSynthesizer.h
 *  everylayer
 *
 *  Created by Andrew on 11/28/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef __TRACK_SYNTHESIZER__
#define __TRACK_SYNTHESIZER__


#include "Synthesizer.h"
#include "Track.h"

#include "stk/Stk.h"
#include "stk/Instrmnt.h"

using namespace std;

// Renderer subclass that knows how to synthesize Tracks
class TrackSynthesizer : public Synthesizer {
	
public:
	// TrackSynthesizer does not own the Track it renders
	TrackSynthesizer(Track *track);
	~TrackSynthesizer();
	
	Track * track();
	
protected:
	stk::StkFloat synthesizeSelf(stk::StkFloat inputSample);
	
	Track *m_track;
	
	vector<stk::Instrmnt *> *m_instruments;
	
	stk::Instrmnt * instrument(unsigned int instrumentID);
};

#endif // __TRACK_SYNTHESIZER__
