//
//  everylayer2AppDelegate.m
//  everylayer2
//
//  Created by Andrew on 12/5/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "everylayer2AppDelegate.h"

#import <Quartz/Quartz.h>
#import "EL2OpenGLView.h"
#import "SharedProjectTableViewController.h"

@implementation everylayer2AppDelegate

@synthesize window, everylayer, sharedProjectsTableView, imageView, nameTextField, titleTextField;

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
	// Insert code here to initialize your application
	
	plistPath = NSHomeDirectory();
	plistPath = [[plistPath stringByAppendingPathComponent:@"everylayer2data.plist"] retain];
	
	sharedProjects = [NSMutableArray arrayWithContentsOfFile:plistPath];
	if (!sharedProjects) {
		sharedProjects = [NSMutableArray array];
	}
	[sharedProjects retain];
	
	tableViewController = [[SharedProjectTableViewController alloc] initWithTableView:sharedProjectsTableView array:sharedProjects];
	
	[sharedProjectsTableView reloadData];
}

- (IBAction)shareButtonHandler:(id)sender {
	// the awesome persistent store solution ;)
	NSString *project = [everylayer projectArchive];
	NSString *info = [[titleTextField stringValue] stringByAppendingFormat:@"\nBy %@", [nameTextField stringValue]];
	
	NSData *imageData = [[imageView image] TIFFRepresentation];
	
	NSDictionary *d = [NSDictionary dictionaryWithObjectsAndKeys:
								project, @"project",
								info, @"info",
								imageData, @"image",
								nil];
	
	[sharedProjects insertObject:d atIndex:0];
	[sharedProjects writeToFile:plistPath atomically:NO];
	
	[sharedProjectsTableView reloadData];
}

- (IBAction)loadButtonHandler:(id)sender {
	if ([sharedProjectsTableView selectedRow] >= 0) {
		NSDictionary *d = [sharedProjects objectAtIndex:[sharedProjectsTableView selectedRow]];
		NSString *project = [d objectForKey:@"project"];
		[everylayer loadProjectArchive:project];
	}
}

- (IBAction)launchImagePicker:(id)sender {
	/* retrieve the imagePicker shared instance */
    IKImagePicker *picker = [IKImagePicker imagePicker];
	
	/* configure the image picker to show effects */
	[picker setValue:[NSValue valueWithSize:NSMakeSize(70,70)] forKey:IKImagePickerOutputImageMaxSizeKey];
	[picker setValue:[NSNumber numberWithBool:YES] forKey:IKImagePickerShowEffectsKey];
	[picker setValue:[NSNumber numberWithBool:NO] forKey:IKImagePickerShowRecentPictureKey];
	[picker setValue:[NSNumber numberWithBool:YES] forKey:IKImagePickerAllowsFileChoosingKey];
	
	/* launch the imagePicker as a panel */
	[picker beginImagePickerWithDelegate:self didEndSelector:@selector(imagePickerValidated:code:contextInfo:) contextInfo:nil];
}


#pragma mark -
#pragma mark delegate

- (void)imagePickerValidated:(IKImagePicker*)imagePicker code:(int)returnCode contextInfo:(void*)ctxInf {
    if(returnCode == NSOKButton){
		/* retrieve the output image */
        NSImage *outputImage = [imagePicker outputImage];
		
		/* change the displayed image */
        [imageView setImage:outputImage];
    }
}

- (BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)theApplication {
	return YES;
}

- (void)dealloc {
	[sharedProjects release];
	sharedProjects = nil;
	
	[super dealloc];
}

@end
